public class DataCM {


    /**data for Cayley-Menger determinant*/

    public static Poly6 f() {
	Poly6 P=new Poly6(fInt());
	return(P);
    }

    public static int[][] fInt() {
int[][] a = {{-2, 2, 2, 0, 2, 0, 0}, {2, 2, 0, 2, 2, 0, 0}, {2, 0, 2, 2, 2, 0, 0}, 
     {-2, 0, 0, 4, 2, 0, 0}, {-2, 0, 0, 2, 4, 0, 0}, {2, 2, 2, 0, 0, 2, 0}, 
     {-2, 0, 4, 0, 0, 2, 0}, {-2, 2, 0, 2, 0, 2, 0}, {2, 0, 2, 2, 0, 2, 0}, 
     {2, 0, 2, 0, 2, 2, 0}, {2, 0, 0, 2, 2, 2, 0}, {-2, 0, 2, 0, 0, 4, 0}, 
     {-2, 4, 0, 0, 0, 0, 2}, {2, 2, 2, 0, 0, 0, 2}, {2, 2, 0, 2, 0, 0, 2}, 
     {-2, 0, 2, 2, 0, 0, 2}, {2, 2, 0, 0, 2, 0, 2}, {2, 0, 0, 2, 2, 0, 2}, 
     {2, 2, 0, 0, 0, 2, 2}, {2, 0, 2, 0, 0, 2, 2}, {-2, 0, 0, 0, 2, 2, 2}, 
     {-2, 2, 0, 0, 0, 0, 4}};
return(a);
    }



    /**This returns the polynomial that is the directional 
       derivative in the given vector direction*/

    public static Poly6 df(int[] q) {
	Poly6 D=new Poly6();
	for(int i=0;i<6;++i) {
	    Poly6 E=df(i);
	    E=E.scale(q[i]);
	    D=Poly6.plus(D,E);
	}
	return(D);
    }

    /**Data for 1st directional derivative of CM det*/


    public static Poly6 df(int k) {
	Poly6 P=new Poly6();
	if(k==0) P=new Poly6(d0fInt());
	if(k==1) P=new Poly6(d1fInt());
	if(k==2) P=new Poly6(d2fInt());
	if(k==3) P=new Poly6(d3fInt());
	if(k==4) P=new Poly6(d4fInt());
	if(k==5) P=new Poly6(d5fInt());
	return(P);
    }

    public static int[][] d0fInt() {
int[][] a= {{-4,1,2,0,2,0,0},{4,1,0,2,2,0,0},{4,1,2,0,0,2,0},
{-4,1,0,2,0,2,0},{-8,3,0,0,0,0,2},{4,1,2,0,0,0,2},
{4,1,0,2,0,0,2},{4,1,0,0,2,0,2},{4,1,0,0,0,2,2},{-4,1,0,0,0,0,4}};
return(a);
  }

    public static int[][] d1fInt() {
int[][] a={{-4,2,1,0,2,0,0},{4,0,1,2,2,0,0},{4,2,1,0,0,2,0},
{-8,0,3,0,0,2,0},{4,0,1,2,0,2,0},{4,0,1,0,2,2,0},
{-4,0,1,0,0,4,0},{4,2,1,0,0,0,2},{-4,0,1,2,0,0,2},{4,0,1,0,0,2,2}};
return(a);
    }

  public static int[][] d2fInt() {
int[][] a={{4,2,0,1,2,0,0},{4,0,2,1,2,0,0},{-8,0,0,3,2,0,0},
{-4,0,0,1,4,0,0},{-4,2,0,1,0,2,0},{4,0,2,1,0,2,0},
{4,0,0,1,2,2,0},{4,2,0,1,0,0,2},{-4,0,2,1,0,0,2},{4,0,0,1,2,0,2}};
return(a);
  }

  public static int[][] d3fInt() {
int[][] a={{-4,2,2,0,1,0,0},{4,2,0,2,1,0,0},{4,0,2,2,1,0,0},
{-4,0,0,4,1,0,0},{-8,0,0,2,3,0,0},{4,0,2,0,1,2,0},
{4,0,0,2,1,2,0},{4,2,0,0,1,0,2},{4,0,0,2,1,0,2},{-4,0,0,0,1,2,2}};
return(a);
  }


  public static int[][] d4fInt() {
int[][] a={{4,2,2,0,0,1,0},{-4,0,4,0,0,1,0},{-4,2,0,2,0,1,0},
{4,0,2,2,0,1,0},{4,0,2,0,2,1,0},{4,0,0,2,2,1,0},
{-8,0,2,0,0,3,0},{4,2,0,0,0,1,2},{4,0,2,0,0,1,2},{-4,0,0,0,2,1,2}};
return(a);
  }

  public static int[][] d5fInt() {
int[][] a={{-4,4,0,0,0,0,1},{4,2,2,0,0,0,1},{4,2,0,2,0,0,1},
{-4,0,2,2,0,0,1},{4,2,0,0,2,0,1},{4,0,0,2,2,0,1},
{4,2,0,0,0,2,1},{4,0,2,0,0,2,1},{-4,0,0,0,2,2,1},{-8,2,0,0,0,0,3}};
return(a);
  }

}