import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;

/**This class lets you work with the simplices
   produced in the ModuliSpace class.*/
  

 public class ModuliSpace2 extends ModuliSpace {



     public static double[] project(int[] a) {
	 double[] b=new double[5];
	 for(int i=0;i<5;++i) b[i]=a[i];
	 return(b);
     }


     public static double[][] project(int[][] a) {
	 double[][] b=new double[6][5];
	 for(int i=0;i<6;++i) b[i]=project(a[i]);
	 return(b);
     }


     public static int[] isInside1(double[] u) {
	 for(int i=0;i<4;++i) {
	     for(int j=0;j<4;++j) {
		 for(int k=0;k<2;++k) {
		     for(int l=0;l<2;++l) {
		         if(i!=j) {
			     double[][] b=project(simplex48(i,j,k,l));
	                    boolean test=Simplex5.inside(b,u);
	                    if(test==true) {
				int[] I={i,j,k,l};
				return(I);
			    }
			 }
		     }
		 }
	     }
	 }
	 int[] I={-1,-1,-1,-1};
	 return(I);
     }


     public static int isInside3(double[] u) {
	 for(int i=0;i<3;++i) {
	     double[][] b=project(simplex3(i));
	     boolean test=Simplex5.inside(b,u);
	     if(test==true) return(i);
	 }
	 return(-1);
     }

     public static int isInside4(double[] u) {
	 for(int i=0;i<4;++i) {
	     double[][] b=project(simplex4(i));
	     boolean test=Simplex5.inside(b,u);
	     if(test==true) return(i);
	 }
	 return(-1);
     }

     public static double[] center(double[][] a) {
	 double[] b=new double[6];
	 for(int i=0;i<6;++i) {
	     b[i]=0;
	     for(int j=0;j<6;++j) {
		 b[i]=b[i]+a[j][i]/6.0;
	     }
	 }
	 return(b);
     }

     public static double[] center(int[][] a) {
	 double[] b=new double[6];
	 for(int i=0;i<6;++i) {
	     b[i]=0;
	     for(int j=0;j<6;++j) {
		 b[i]=b[i]+a[j][i]/6.0;
	     }
	 }
	 return(b);
     }

     public static double[] randomInside() {
	 int k=random(3);
	 return(randomInside(k));
     }


     public static int random(int k) {
	 double d=Math.floor(k*Math.random());
	 int n=(int)(d);
	 return(n);
     }



     public static double[] randomInside(int i) {
	 int[][] a=simplex3(i);
	 double[] u=new double[6];
	 for(int q=0;q<6;++q) u[q]=Math.random();
	 double sum=0;
	 for(int q=0;q<6;++q) sum=sum+u[q];
	 for(int q=0;q<6;++q) u[q]=u[q]/sum;
	 return(map(a,u));
     }


     /**produces a random point inside a simplex48*/

     public static double[] randomInside(int i,int j,int k,int l) {
	 int[][] a=simplex48(i,j,k,l);
	 double[] u=new double[6];
	 for(int q=0;q<6;++q) u[q]=Math.random();
	 double sum=0;
	 for(int q=0;q<6;++q) sum=sum+u[q];
	 for(int q=0;q<6;++q) u[q]=u[q]/sum;
	 return(map(a,u));
     }


     public static double[] randomInside(int[][] a) {
	 double[] u=new double[6];
	 for(int q=0;q<6;++q) u[q]=Math.random();
	 double sum=0;
	 for(int q=0;q<6;++q) sum=sum+u[q];
	 for(int q=0;q<6;++q) u[q]=u[q]/sum;
	 return(map(a,u));
     }



     public static double[] map(int[][] a,double[] u) {
	 double[] b=new double[6];
	 for(int q=0;q<6;++q) {
	     for(int r=0;r<6;++r) {
                  b[r]=b[r]+u[q]*a[q][r];
	     }
	 }
	 return(b);
     }

     public static int[] map(int[][] a,int[] u) {
	 int[] b=new int[6];
	 for(int q=0;q<6;++q) {
	     for(int r=0;r<6;++r) {
                  b[r]=b[r]+u[q]*a[q][r];
	     }
	 }
	 return(b);
     }


}

