import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    ListenSquare GO0,GO2,GO1,GO3,STOP0,STOP2,STOP1,STOP3,PIX;
    Debugger DE;
    PositiveDominance PD;
    Experimenter EX;
    ControlPanel DEBUG,ACTION,EXP,GROUP,SAVE;
    SelectInteger TOLERANCE,PLOTNUMBER;
    CalculationMonitor CM;
    SimplexManager SM;
    FunctionManager FM;
    NegativeFinder NF;
    long STEPS;
    Point POINT;
    ListenSquare[] INFO=new ListenSquare[10];
    Complex[] PLOT=new Complex[65536];
    GeneralPath LINE,ARC;
    int COUNT;

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(200,315,.01);

	 /**go/stop buttons*/
	 GO0=new ListenSquare(135,5,25,20);  //debugger
	 STOP0=new ListenSquare(165,5,40,20); //debugger

	 GO2=new ListenSquare(5,250,25,20);   //certify
	 STOP2=new ListenSquare(5,275,40,20); //certify

	 GO3=new ListenSquare(5,155,25,20);   //anti certify
	 STOP3=new ListenSquare(5,180,40,20); //anti certify

	 GO1=new ListenSquare(5,100,25,20);   //experiment
	 STOP1=new ListenSquare(35,100,40,20); //experiment

	 /**algorithm halting tolerance*/
	 TOLERANCE=new SelectInteger(20,210,40,20,6,1,10,1);

	 /**plot number*/
	 PLOTNUMBER=new SelectInteger(300,100,40,20,12,8,16,1);

	 /**information buttons*/
	 INFO[0]=new ListenSquare(3,215,12,12);
	 INFO[1]=new ListenSquare(0,300,12,12);
	 INFO[2]=new ListenSquare(390,2,12,12);
	 INFO[3]=new ListenSquare(390,300,12,12);

	 /**runnable threads*/
	 DE=new Debugger();
	 PD=new PositiveDominance();
	 EX=new Experimenter();
	 NF=new NegativeFinder();

	 /**auxiliary interfaces*/
	 CM=new CalculationMonitor(5,300);
	 FM=new FunctionManager(390,2);
	 SM=new SimplexManager(390,300,FM);
	 STEPS=0;
	 setPanels();

	 /**Plot window*/
	 PIX=new ListenSquare(5,135,375,375);
	 LINE=new GeneralPath();
	 ARC=new GeneralPath();
     }


    public void setPanels() {  
	Color[] C1={new Color(100,0,150),Color.white,Color.white,Color.white,new Color(180,180,180)};
	String[] DebugString={"cayley menger","CM derivatives","cube transform","poly dilate","poly rotate","poly reflect","sign evaluation","misc","debugger"};
	int[] DebugState={1,0,0,0,0,0,0,0};
         DEBUG=new ControlPanel(C1,DebugString,DebugState,8);
	 DEBUG.mode=0;

	 String[] ActionString={"debugger","experiment","certify","anti certify","action"};
	 int[] ActionState={0,1,0,0};
         ACTION=new ControlPanel(C1,ActionString,ActionState,4);
	 ACTION.mode=1;

	 String[] ExpString={"f\u22650 \u21D2 df\u22650","a(f)+b(df)\u22650","plot (f,df)","tests"};
	 int[] ExpState={1,0,0};
         EXP=new ControlPanel(C1,ExpString,ExpState,3);
	 EXP.mode=0;

	 String[] GroupString={"single","group","batch"};
	 int[] GroupState={1,0};
         GROUP=new ControlPanel(C1,GroupString,GroupState,2);
	 GROUP.mode=0;

	 String[] SaveString={"no","yes","export polys"};
	 int[] SaveState={1,0};
         SAVE=new ControlPanel(C1,SaveString,SaveState,2);
	 SAVE.mode=0;

    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
      if(ACTION.mode==1) drawPlot(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,100));
        g.fillRect(0,0,getWidth(),getHeight());
    }

    public void drawControls(Graphics2D g) { 
	ACTION.render(g,5,5,120); 
	if(ACTION.mode==0) drawDebugMode(g);
	if(ACTION.mode==1) drawTestMode(g);
	if(ACTION.mode==2) drawCertifyMode(g);
	if(ACTION.mode==3) drawAnticertifyMode(g);
        if(ACTION.mode!=0) INFO[2].infoRender(g);
        if(ACTION.mode!=0) INFO[3].infoRender(g);
    }


    public void drawDebugMode(Graphics2D g) {
       DEBUG.render(g,5,90,120);
       GO0.render(g,"go",12,3,new Color(0,160,0));
       if(DE.HALT==false) STOP0.render(g,"stop",12,3,new Color(255,0,0));
    }

  public void drawTestMode(Graphics2D g) {
       g.setFont(new Font("Helvetica",Font.PLAIN,12));
       Color C1=new Color(70,0,100);
       if(EX.HALT==false) C1=Color.black;
       GO1.render(g,"go",12,3,new Color(0,160,0));
       if(EX.HALT==false) STOP1.render(g,"stop",12,3,new Color(255,0,0));
       FM.render(g);
       SM.render(g); 
       GROUP.render(g,130,5,120);
       EXP.render(g,255,5,120);
       if(EXP.mode<2) drawSteps(g);
       if(EXP.mode==2) {
           PLOTNUMBER.render(g,Color.red,Color.white,Color.white);
	   g.drawString("log2(# of points)",170,116);
       }
  }


    /**This is the plotter*/
    public void drawPlot(Graphics2D g) {
	PIX.render(g,Color.black);
	g.clipRect(6,136,373,373);
	GeneralPath gp=new GeneralPath();
	int N=100000;
	int n=1000;


	for(int i=-100;i<=100;++i) {
	   gp.reset();
	   gp.moveTo(-N,i*n);
	   gp.lineTo(N,i*n);
	   gp.moveTo(i*n,-N);
	   gp.lineTo(i*n,N);
	   gp=transform(gp);
	   g.setColor(new Color(0,0,100));
	   g.draw(gp);
	}

	for(int i=0;i<COUNT;++i) {
	    fillPoint(g,PLOT[i],.1,new Color(255,125,0),4);
	}

	gp=transform(LINE);
	g.setColor(new Color(0,0,255));
	g.draw(gp);

	gp=transform(ARC);
	g.setColor(new Color(255,255,0));
	g.draw(gp);
    }

    public void scaleNicely() {	
       AffineTransform[] AA=preFit(ARC,6,136,373,373);
       A[0]=AA[0];
       A[1]=AA[1];
    }





  public void drawCertifyMode(Graphics2D g) {
       g.setFont(new Font("Helvetica",Font.PLAIN,12));
       Color C1=new Color(70,0,100);
       if(PD.HALT==false) C1=Color.black;
       GO2.render(g,"go",12,3,new Color(0,160,0));
       if(PD.HALT==false) STOP2.render(g,"stop",12,3,new Color(255,0,0));
       FM.render(g);
       SM.render(g);
       CM.render(g,PD.HALT);
       GROUP.render(g,130,5,120);   
       SAVE.render(g,255,5,120);
       TOLERANCE.render(g,new Color(200,0,200),Color.white,Color.white); 
       for(int i=0;i<2;++i) INFO[i].infoRender(g);
  }

  public void drawAnticertifyMode(Graphics2D g) {
       FM.render(g);
       SM.render(g);
       GROUP.render(g,130,5,120); 
       GO3.render(g,"go",12,3,new Color(0,160,0));
       if(NF.HALT==false) STOP3.render(g,"stop",12,3,new Color(255,0,0));   
       TOLERANCE.render(g,new Color(200,0,200),Color.white,Color.white); 
       INFO[0].infoRender(g);
  }

    public void drawSteps(Graphics2D g) {
	Long S=new Long(STEPS);
	g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.setColor(Color.white);
	g.drawString(S.toString(),180,120);
    }




/**This handles the launching of the programs*/
    public void action(Point X) {
	if((ACTION.mode==0)&&(GO0.inside(X)==1)) run0();
	if((ACTION.mode==1)&&(GO1.inside(X)==1)) run1();
	if((ACTION.mode==2)&&(GO2.inside(X)==1)) run2();
	if((ACTION.mode==3)&&(GO3.inside(X)==1)) run3();
	if((ACTION.mode==0)&&(STOP0.inside(X)==1)) stop0();
	if((ACTION.mode==1)&&(STOP1.inside(X)==1)) stop1();
	if((ACTION.mode==2)&&(STOP2.inside(X)==1)) stop2();
	if((ACTION.mode==3)&&(STOP3.inside(X)==1)) stop3();
    }

    public void run0() {
	if(DE.HALT==true) {
	  DE=new Debugger(this);
          new Thread(DE).start();
	}
    }

    public void run1() {
	if(EX.HALT==true) {
	  EX=new Experimenter(this);
          new Thread(EX).start();
	}
    }

    public void run2() {
	if(PD.HALT==true) {
	  PD=new PositiveDominance(this);
          new Thread(PD).start();
	}
    }

    public void run3() {
	System.out.println("used");
	if(NF.HALT==true) {
	  NF=new NegativeFinder(this);
          new Thread(NF).start();
	}
    }

    public void stop0() {
	DE.HALT=true;
    }

    public void stop1() {
	EX.HALT=true;
    }

    public void stop2() {
	PD.HALT=true;
    }

    public void stop3() {
	NF.HALT=true;
    }
    /**The end of the action control*.




    /**Documentation*/

    public void documentAux(Point X) {
	if((ACTION.mode==2)&&(INFO[0].inside(X)==1)) docCertify(4);
	if((ACTION.mode==3)&&(INFO[0].inside(X)==1)) docAnticertify(4);
	if(INFO[1].inside(X)==1) docCertify(5);
	if(INFO[2].inside(X)==1) DocumentFunction.main(M.D);
	if(INFO[3].inside(X)==1) DocumentSimplex.main(M.D);
	docSimplices(X);
    }

    public void docDebug(int t) {
	if(ACTION.mode!=0) return;
	if(t==0) DocumentDebugger.cayley(M.D);
	if(t==1) DocumentDebugger.derivatives(M.D);
	if(t==2) DocumentDebugger.cubeTransform(M.D);
	if(t==3) DocumentDebugger.dilate(M.D);;
	if(t==4) DocumentDebugger.rotate(M.D);
	if(t==5) DocumentDebugger.reflect(M.D);
	if(t==6) DocumentDebugger.sign(M.D);
	if(t==7) DocumentDebugger.misc(M.D);
    }

    public void docAction(int t) {
	if(t==0) DocumentDebugger.actionDebug(M.D);
	if(t==1) DocumentExperiment.experiment(M.D);
	if(t==2) DocumentCertify.certify(M.D);
	if(t==3) DocumentAnticertify.anticertify(M.D);
    }

    public void docAnticertify(int t) {
	if(t==0) DocumentAnticertify.single(M.D);
	if(t==1) DocumentAnticertify.group(M.D);
    }

    public void docCertify(int t) {
	if(t==0) DocumentCertify.single(M.D);
	if(t==1) DocumentCertify.group(M.D);
	if(t==2) DocumentCertify.saveNo(M.D);
	if(t==3) DocumentCertify.saveYes(M.D);
	if(t==4) DocumentCertify.tolerance(M.D);
	if(t==5) DocumentCertify.monitor(M.D);
    }

    public void docExperiment(int t) {
	if(t==0) DocumentExperiment.single(M.D);
	if(t==1) DocumentExperiment.group(M.D);
	if(t==2) DocumentExperiment.test1(M.D);
	if(t==3) DocumentExperiment.test2(M.D);
	if(t==4) DocumentExperiment.test3(M.D);
    }

    public void docSimplices(Point X) {
	int t=SM.CHOICE.switchMode(X);
	if(t==0) DocumentSimplex.simplex3(M.D);
	if(t==1) DocumentSimplex.simplex4(M.D);
	if(t==2) DocumentSimplex.simplex12(M.D);
	if(t==3) DocumentSimplex.simplex48(M.D);
    }


    /**mouse events*/


    public void mousePressed(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	action(J.X);
	int test=0;
	if(ACTION.mode==0) {
	   test=DEBUG.switchMode(J.X);
	   docDebug(test);
	}

	if(ACTION.mode==1) {
	   EXP.switchMode(J.X);
	   test=GROUP.switchMode(J.X);
	   if(test!=-1) docExperiment(test);
	   test=EXP.switchMode(J.X);
	   if(test!=-1) docExperiment(test+2);
	   PLOTNUMBER.modify(J.X);
	}

	if(ACTION.mode==2) {
	    test=GROUP.switchMode(J.X);
	    if(test==0) docCertify(0);
	    if(test==1) docCertify(1);
	    test=SAVE.switchMode(J.X);  
            if(test==0) docCertify(2);
	    if(test==1) docCertify(3);
	    TOLERANCE.modify(J.X);
	}

	if(ACTION.mode==3) {
	    test=GROUP.switchMode(J.X);
	    if(test==0) docAnticertify(0);
	    if(test==1) docAnticertify(1);
	    TOLERANCE.modify(J.X);
	}

	if((ACTION.mode==1)&&(PIX.inside(J.X)==1)) {
	    if(J.mode==1) scaleUp(J.X,-1);
	    if(J.mode==3) scaleUp(J.X,+1);


	}

	test=ACTION.switchMode(J.X); 
	docAction(test);
	SM.process(J.X);
	FM.process(J.X);
	documentAux(J.X);
	repaint();
    }

     public void mouseDragged(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}  

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	POINT=new Point(J.X);
     }

    /**Key events*/

     public void keyReleased(KeyEvent e) {}   
     public void keyPressed(KeyEvent e) {}
     public void keyTyped(KeyEvent e) {
	SM.keyProcess(e,POINT);	
        char b=e.getKeyChar();
	boolean used=false;
	if(b=='z') {scaleUp(POINT,1);used=true;}
	if(b=='c') {scaleUp(POINT,-1);used=true;}
        if(b=='x') {setScales(200,315,.01);used=true;}
	if(b=='f') {scaleNicely();used=true;}
	if(used==false) clearPlot();
	repaint();
     }

    /**clear the plot*/
    public void clearPlot() {
 	LINE=new GeneralPath();
	ARC=new GeneralPath();
	COUNT=0;
    }

     


}

