
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.util.Arrays;


public class SimplexManager {
    FunctionManager FM;
    ControlPanel CHOICE;
    ListenSquare[] S3=new ListenSquare[3];
    ListenSquare[] S4=new ListenSquare[4];
    ListenSquare[][] S12=new ListenSquare[4][4];
    ListenSquare[][][][] S48=new ListenSquare[4][4][2][2];
    int[][][][] STEPS48=new int[4][4][2][2];
    int[][] STEPS12=new int[4][4];
    Permutation PER;
    int N3,N4;
    int[] N12=new int[2];
    int[] N48=new int[4];
    int X,Y;
    ListenSquare FRAME,FRAME2;

    public SimplexManager(int x,int y,FunctionManager fm) {
	X=x;
	Y=y;
	setPanels();
	setSquares();
	PER=new Permutation(X,Y+120,6);
	N3=0;
	N4=0;
	N12[0]=0;
	N12[1]=1;

	N48[0]=0;
	N48[1]=1;
	N48[2]=0;
	N48[3]=0;
	FM=fm;
	FRAME=new ListenSquare(X,Y,270,210);
	FRAME2=new ListenSquare(X+90,Y+30,172,128);

    }


    public void setSquares() {

	for(int i=0;i<3;++i) {
	    S3[i]=new ListenSquare(X+90,Y+30+44*i,172,40);
	}


	for(int i=0;i<4;++i) {
	    S4[i]=new ListenSquare(X+90+44*i,Y+30,40,128);
	}



	for(int i=0;i<4;++i) {
	    for(int j0=0;j0<4;++j0) {
		int j=(i-j0+4)%4-1;
		if(i%2==0) j=2-j;
		S12[i][j0]=new ListenSquare(X+90+44*i,Y+30+44*j,40,40);
	    }
	}


	for(int i=0;i<4;++i) {
	    for(int j0=0;j0<4;++j0) {
		for(int k=0;k<2;++k) {
		    for(int l=0;l<2;++l) {
			int j=(i-j0+4)%4-1;
	                if(i%2==0) j=2-j;
			S48[i][j0][k][l]=new ListenSquare(X+90+44*i+20*k,Y+30+44*j+20*l,20,20);
		    }
		}
	    }
	}



    }


    public void setPanels() { 
 
	Color[] C1={new Color(20,20,255),
        Color.white,Color.white,Color.white,
        new Color(180,180,180)};
	 String[] ChoiceString={"3","4","12","48","partition"};
	int[] ChoiceState={0,0,0,1};
         CHOICE=new ControlPanel(C1,ChoiceString,ChoiceState,4);
	 CHOICE.mode=3;
    }

    public void render(Graphics2D g) {
	FRAME.render(g,new Color(80,0,80));
	g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.drawString("simplex manager",X+65,Y+18);
	g.drawRect(X,Y,270,210);
	CHOICE.render(g,X,Y+30,82);


	if(CHOICE.mode==0) {
	    for(int i=0;i<3;++i) {
		Color C=new Color(0,0,0);
		if(i==N3) C=Color.white;
		S3[i].render(g,C);
	    }
	}

	if(CHOICE.mode==1) {
	    for(int i=0;i<4;++i) {
		Color C=new Color(0,0,0);
		if(i==N4) C=Color.white;
		S4[i].render(g,C);
	    }
	}

	if(CHOICE.mode==2) {
	    for(int i=0;i<4;++i) {
		for(int j=0;j<4;++j) {
		    Color C=new Color(0,0,0);
                    if(S12[i][j].state==1) C=new Color(50,100,255);
		    if(S12[i][j].state==2) C=new Color(0,160,0);
		    if(S12[i][j].state==3) C=new Color(100,100,100);
		    if(S12[i][j].state==4) C=new Color(180,0,0);  
		    if(S12[i][j].state==5) C=new Color(255,255,0);  
                    if(i!=j) S12[i][j].render(g,C);
		    int[] I={i,j};
		    if(match(I,N12)==true) {
		       S12[i][j].renderShrink(g,Color.white);
		    }
		}
	    }
	}

	
        if(CHOICE.mode==3) {
	    for(int i=0;i<4;++i) {
		for(int j=0;j<4;++j) {
		    for(int k=0;k<2;++k) {
			for(int l=0;l<2;++l) {
		           Color C=new Color(0,0,0);
			   if(S48[i][j][k][l].state==1) C=new Color(50,100,255);
			   if(S48[i][j][k][l].state==2) C=new Color(0,160,0);
			   if(S48[i][j][k][l].state==3) C=new Color(100,100,100);
			   if(S48[i][j][k][l].state==4) C=new Color(180,0,0);
			   if(S48[i][j][k][l].state==5) C=new Color(255,255,0);  
			   if(S48[i][j][k][l].state==6) C=new Color(150,0,150);  
                           if(i!=j) S48[i][j][k][l].render(g,C);
			   int[] I={i,j,k,l};
			   if(match(I,N48)==true) {
		              S48[i][j][k][l].renderShrink(g,Color.white);
			   }
			}
		    }
		}
	    }
	}
	PER.render(g,new Color(0,60,140));
	int[][] a=getSimplex();
	for(int i=0;i<3;++i) printout(g,a[i],X+90,Y+175+15*i);
	for(int i=3;i<6;++i) printout(g,a[i],X+195,Y+130+15*i);

    }

    public static boolean match(int[] a,int[] b) {
	if(a.length!=b.length) return(false);
	for(int i=0;i<a.length;++i) {
	    if(a[i]!=b[i]) return(false);
	}
	return(true);
    }


    public void process3(Point X) {
	int i=locate3(X);
	if(i!=-1) N3=i;
    }

    public void process4(Point X) {
	int i=locate4(X);
	if(i!=-1) N4=i;
    }

    public void process12(Point X) {
	int[] I=locate12(X);
	if(I[0]!=-1) N12=I;
    }

    public void process48(Point X) {
	int[] I=locate48(X);
	if(I[0]!=-1) N48=I;
    }

    public void state48(Point X,int k) {
	int[] I=locate48(X);
	if(I[0]!=-1) {
	    S48[I[0]][I[1]][I[2]][I[3]].state=k;
	}
    }

    public void steps48(Point X,int k) {
	int[] I=locate48(X);
	if(I[0]!=-1) {
	    int n=STEPS48[I[0]][I[1]][I[2]][I[3]];
	    System.out.println("steps "+n);
	}
    }

    public void steps12(Point X,int k) {
	int[] I=locate12(X);
	if(I[0]!=-1) {
	    int n=STEPS12[I[0]][I[1]];
	    System.out.println("steps "+n);
	}
    }

    public void state12(Point X,int k) {
	int[] I=locate12(X);
	if(I[0]!=-1) {
	    S12[I[0]][I[1]].state=k;
	}
    }




    public int locate3(Point X) {
	for(int i=0;i<3;++i) {
	    if(S3[i].inside(X)==1) return(i);
	}
	return(-1);
    }

    public int locate4(Point X) {
         for(int i=0;i<4;++i) {
	     if(S4[i].inside(X)==1) return(i);
	 }
	 return(-1);
    }

    public int[] locate12(Point X) {
           for(int i=0;i<4;++i) {
		for(int j=0;j<4;++j) {
		    if(S12[i][j].inside(X)==1) {
			int[] I={i,j};
			return(I);
		    }
		}
	    }
	   int[] A={-1,-1};
	   return(A);
    }

    public int[] locate48(Point X) {
           for(int i=0;i<4;++i) {
		for(int j=0;j<4;++j) {
		    for(int k=0;k<2;++k) {
			for(int l=0;l<2;++l) {
		           if(S48[i][j][k][l].inside(X)==1) {
			       int[] I={i,j,k,l};
			       return(I);
			   }
			}
		    }
		}
	    }
	   int[] A={-1,-1,-1,-1};
	   return(A);
    }


    public void totalSelect(int q) {
           for(int i=0;i<4;++i) {
		for(int j=0;j<4;++j) {
		    for(int k=0;k<2;++k) {
			for(int l=0;l<2;++l) {
			    S48[i][j][k][l].state=q;
			    S12[i][j].state=q;
			    STEPS48[i][j][k][l]=0;
			    STEPS12[i][j]=0;
			}
		    }
		}
	    }
    }


    public void transmitCurrent() {
	int[][] a=getSimplex();
	double[] c=ModuliSpace2.randomInside(a);
        double s1=c[0]+c[1]+c[2];
	double s2=c[0]+c[3]+c[4];
	double s3=c[1]+c[3]+c[5];
	double s4=c[2]+c[4]+c[5];
	double[] ss={s1,s2,s3,s4};
	int[] s=rankList(ss);
	FM.TRIPOD=s;
	double t1=c[0]+c[5];
	double t2=c[1]+c[4];
	double t3=c[2]+c[3];
	double[] tt={t1,t2,t3};
	int[] t=rankList(tt);
	int[][] OPP={{0,1,2,3},{0,2,1,3},{0,3,1,2}};
	if(t[0]==1) FM.OPP1=OPP[0];
	if(t[1]==1) FM.OPP1=OPP[1];
	if(t[2]==1) FM.OPP1=OPP[2];
	if(t[0]==2) FM.OPP2=OPP[0];
	if(t[1]==2) FM.OPP2=OPP[1];
	if(t[2]==2) FM.OPP2=OPP[2];
    }


    public void printout(Graphics2D g,int[] a,int x,int y) {
	int n=a.length;
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.setColor(Color.white);
	for(int i=0;i<n;++i) {
	    Integer A=new Integer(a[i]);
	    g.drawString(A.toString(),x+12*i,y);
	}
    }



    public int[][] getSimplex() {
	int[][] a=getSimplex0();
	int[] p=PER.getPermutation();
	int[][] b=new int[6][6];
	for(int i=0;i<6;++i) b[i]=a[p[i]];
	return(b);
    }



    public int[][] getSimplex0() {
	if(CHOICE.mode==0) {
	    return(ModuliSpace.simplex3(N3));
	}
	if(CHOICE.mode==1) {
	    return(ModuliSpace.simplex4(N4));
	}
	if(CHOICE.mode==2) {
	    int a0=N12[0];
	    int a1=N12[1];
	    return(ModuliSpace.simplex12(a0,a1));
	}
	if(CHOICE.mode==3) {
	    int a0=N48[0];
	    int a1=N48[1];
	    int a2=N48[2];
	    int a3=N48[3];
	    return(ModuliSpace.simplex48(a0,a1,a2,a3));
	}
	return(null);
    }

    public int[] rankList(double[] d) {
	int n=d.length;
	int[] e=new int[n];
	for(int i=0;i<n;++i) {
	    e[i]=(int)(Math.floor(1000*d[i])*1000+i);
	}
	Arrays.sort(e);
	for(int i=0;i<n;++i) {
	    e[i]=e[i]%10;
	}
	int[] f=new int[n];
	for(int i=0;i<n;++i) f[e[i]]=i;
	return(f);
    }



    public void process(Point P) {
	CHOICE.switchMode(P);
	if(CHOICE.mode==0) process3(P);
	if(CHOICE.mode==1) process4(P);
	if(CHOICE.mode==2) process12(P);
	if(CHOICE.mode==3) process48(P);	
        PER.process(P);
	if(FRAME2.inside(P)==1) transmitCurrent();
    }


    public void keyProcess(KeyEvent e,Point X) {
	if(FRAME2.inside(X)==0) return;
	char c=e.getKeyChar();
	boolean used=false;
	if((c=='1')&&(CHOICE.mode==2)) {state12(X,1);used=true;}
        if((c=='0')&&(CHOICE.mode==2)) {state12(X,0);used=true;}
        if((c=='i')&&(CHOICE.mode==2)) {steps12(X,0);used=true;}
        if((c=='1')&&(CHOICE.mode==3)) {state48(X,1);used=true;}
        if((c=='0')&&(CHOICE.mode==3)) {state48(X,0);used=true;}
        if((c=='i')&&(CHOICE.mode==3)) {steps48(X,0);used=true;}
	if(c=='s') {totalSelect(1);used=true;}
	if(used==false) totalSelect(0);
    }

}

